; 
    include \masm32\include\masm32rt.inc
    .586
    include timers.asm 

    cmpmema PROTO buf1:DWORD,buf2:DWORD,bcnt:DWORD
    _cmpmema PROTO buf1:DWORD,buf2:DWORD,bcnt:DWORD

; 
    .data
        pmem1 dd 0
        pmem2 dd 0
    .code
; 
start:
; 
    BLOCK_SIZE EQU 1024*4
    LOOP_COUNT EQU 1000000

    mov   pmem1, alloc(BLOCK_SIZE)
    mov   pmem2, alloc(BLOCK_SIZE)

    invoke memfill, pmem1, BLOCK_SIZE, "YYYY"
    invoke memfill, pmem2, BLOCK_SIZE, "YXYY"
    invoke cmpmema, pmem1, pmem2, BLOCK_SIZE
    print ustr$(eax),13,10

    invoke memfill, pmem1, BLOCK_SIZE, "YYYY"
    invoke memfill, pmem2, BLOCK_SIZE, "YZYY"
    invoke cmpmema, pmem1, pmem2, BLOCK_SIZE
    print ustr$(eax),13,10

    invoke memfill, pmem1, BLOCK_SIZE, "YYYY"
    invoke memfill, pmem2, BLOCK_SIZE, "YYYY"
    invoke cmpmema, pmem1, pmem2, BLOCK_SIZE
    print ustr$(eax),13,10

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke cmpmema, pmem1, pmem2, BLOCK_SIZE
    counter_end
    print ustr$(eax)," cycles",13,10

    invoke memfill, pmem1, BLOCK_SIZE, "YYYY"
    invoke memfill, pmem2, BLOCK_SIZE, "YXYY"
    invoke _cmpmema, pmem1, pmem2, BLOCK_SIZE
    print ustr$(eax),13,10

    invoke memfill, pmem1, BLOCK_SIZE, "YYYY"
    invoke memfill, pmem2, BLOCK_SIZE, "YZYY"
    invoke _cmpmema, pmem1, pmem2, BLOCK_SIZE
    print ustr$(eax),13,10

    invoke memfill, pmem1, BLOCK_SIZE, "YYYY"
    invoke memfill, pmem2, BLOCK_SIZE, "YYYY"
    invoke _cmpmema, pmem1, pmem2, BLOCK_SIZE
    print ustr$(eax),13,10

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke _cmpmema, pmem1, pmem2, BLOCK_SIZE
    counter_end
    print ustr$(eax)," cycles",13,10

    free pmem1
    free pmem2

    mov   eax, input(13,10,"Press enter to exit...")
    exit

; 

align 4

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

cmpmema proc buf1:DWORD,buf2:DWORD,bcnt:DWORD

; ---------------------------------------
; compare 2 4 byte aligned memory buffers
; ---------------------------------------

    push esi
    push edi

    mov edx, [esp+20]               ; bcnt
    shr edx, 2                      ; div by 4

    mov esi, [esp+12]               ; buf1
    mov edi, [esp+16]               ; buf2
    xor ecx, ecx

  align 4
  @@:
    mov eax, [esi+ecx]              ; DWORD compare main file
    cmp eax, [edi+ecx]
    jne nxt
    add ecx, 4
    sub edx, 1
    jnz @B

    mov edx, [esp+20]               ; bcnt  calculate any remainder
    and edx, 3
    jz match                        ; exit if its zero
    xor eax, eax
    jmp @F

  nxt:
    mov edx, 4                      ; set counter for 4 bytes
    xor eax, eax                    ; clear EAX for partial writes

  @@:
    mov al, [esi+ecx]               ; BYTE compare tail
    cmp al, [edi+ecx]
    jg greater
    jl lessthan
    add ecx, 1
    sub edx, 1
    jnz @B

    jmp match

  greater:
    mov eax, 1
    jmp quit

  lessthan:
    mov eax, -1
    jmp quit

  match:
    xor eax, eax                    ; return ZERO on match

  quit:
    pop edi
    pop esi

    ret 12

; -------------------------------------------------

cmpmema endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
; 

; 

align 4

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

_cmpmema proc buf1:DWORD,buf2:DWORD,bcnt:DWORD

; ---------------------------------------
; compare 2 4 byte aligned memory buffers
; assumes bcnt is a multiple of 16
; ---------------------------------------

    push ebx 
    push esi
    push edi

    mov edx, [esp+24]               ; bcnt
    shr edx, 4                      ; div by 16

    mov esi, [esp+16]               ; buf1
    mov edi, [esp+20]               ; buf2
    xor ecx, ecx

  align 4
  @@:
    mov eax, [esi+ecx]              ; 2 DWORDs per loop
    mov ebx, [esi+ecx+4]
    xor eax, [edi+ecx]
    xor ebx, [edi+ecx+4]
    and eax, ebx
    jnz nxt
    mov eax, [esi+ecx+8]             ; 2 more DWORDs per loop
    mov ebx, [esi+ecx+12]
    xor eax, [edi+ecx+8]
    xor ebx, [edi+ecx+12]
    and eax, ebx
    jnz nxt
    
    add ecx, 16
    sub edx, 1
    jnz @B

    mov edx, [esp+24]               ; bcnt calculate any remainder
    and edx, 3
    jz match                        ; exit if its zero
    xor eax, eax
    jmp @F

  nxt:
    mov edx, 8                      ; set counter for 8 bytes
    xor eax, eax                    ; clear EAX for partial writes

  @@:
    mov al, [esi+ecx]               ; BYTE compare tail
    cmp al, [edi+ecx]
    jg greater
    jl lessthan
    add ecx, 1
    sub edx, 1
    jnz @B

    jmp match

  greater:
    mov eax, 1
    jmp quit

  lessthan:
    mov eax, -1
    jmp quit

  match:
    xor eax, eax                    ; return ZERO on match

  quit:
    pop edi
    pop esi
    pop ebx

    ret 12

; -------------------------------------------------

_cmpmema endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
; 

end start
 